Program Coarsen
use sep
use coarsen_norm
!use coarsen
!use dottest

implicit none

! declarations
  integer                                  :: nsc, tt(1000), i, dim, nb,stat
  integer, external                        :: getch
  integer, dimension (:),   allocatable    :: nn, cn
  real,    dimension (:),   allocatable    :: oo, dd, co, cd, obank
  logical, dimension (:),   allocatable    :: lbank
  integer, dimension (:,:), allocatable    :: nbank
  real,    dimension (:),   allocatable    :: data,outdata
  real,    dimension (:),   pointer        :: mask
  real,    dimension (2)                   :: dot1, dot2

! read from history, param
 !                                                                          write(0,*)"BoundB 1"
  call sep_init(SOURCE)
  dim = sep_dimension()

 !                                                                          write(0,*)"BoundB 2"
  allocate (nn (dim), oo (dim), dd (dim), cn(dim))
  allocate (co(dim), cd(dim))
!                                                                           write(0,*)"BoundB 3"

  call from_history ("n",nn)
  call from_history ("o",oo)
  call from_history ("d",dd)

 !                                                                          write(0,*)"BoundB 4"
  call from_param ("cn",cn)

!                                                                           write(0,*)"BoundB 5"

!                                                                           write(0,*)"BoundB 6",product(nn)
! allocations
  allocate (mask (product(nn)),data (product(nn)), outdata(product(cn)))

!                                                                           write(0,*)"BoundB 6.1",sc
! read in mask
  call sep_read( data )
  call sep_read( mask, "mask")

 !                                                                          write(0,*)"BoundB 7.1"
! put below in subprogram

call coarsen_norm_init(oo,dd,nn,co,cd,cn,mask)
 !                                                                          write(0,*)"BoundB 10"
!call dot_test(coarsen_lop,product(nbank(2,:)),product(nn),dot1,dot2)
!                                                                           write(0,*)"BoundB 11"
stat=coarsen_norm_lop(.true.,.false.,outdata,data)
! write out boundbak
  call to_history("n1",cn(1))
  call to_history("n2",cn(2))
  call to_history("o1",co(1))
  call to_history("o2",co(2))
  call to_history("d1",cd(1))
  call to_history("d2",cd(2))
  call sep_write (outdata)
  call sep_close ()
  call exit (0)
! deallocate stuff
  deallocate(nn,oo,dd,cn,co,cd,data,outdata,mask)
end Program Coarsen
