program MakeMask2p

use sep

implicit none

integer                                 :: n1, n2, i1, i2, well2, nknown, k1, k2, iseed, tt(1000)
real                                    :: o1, o2, d1, d2, rand1, rand2, f, g, t
real                                    :: lag, count
real, dimension(:,:), allocatable       :: mask,data
integer, external                       :: getch
integer, dimension (:),   allocatable   :: known



call sep_init(SOURCE)

call from_param("n1", n1);  call from_param("n2", n2)
call from_param("d1", d1);  call from_param("d2", d2)
call from_param("o1", o1);  call from_param("o2", o2)

!call from_param("datalag", lag, d1)
!call from_param("nknown", nknown, nint(n1*n2/100.) )
!call from_param("seed", iseed, 23450952 )
nknown = getch("known","d",tt)
allocate( known(nknown))
known(1:nknown)=tt(1:nknown)
call from_param ("known", known)

call to_history("n1", n1);  call to_history("n2", n2)
call to_history("d1", d1);  call to_history("d2", d2)
call to_history("o1", o1);  call to_history("o2", o2)

allocate( mask(n1,n2) );  
mask = 0.0


do i2=1,nknown
   mask( :,known(i2) ) = 1.0
end do

call sep_write(mask)

deallocate( mask)

end program MakeMask2p
